#include "graph.h"
#include "util.h"
#include <time.h>
#include "randlib.h"

float Vtask[4];
float Vmach[4]; 
int** ETC;

int prog(int notask, int nproc, double rcom, int ETCType, char* inputFileName, char* outputFileName);

int Random(int m){
	return m*((double)rand()/(RAND_MAX));
}

void createETC(int type, int notask, int nproc)
{
	int i, j;
	float alphatask;
	float alphamach;
	float* betatask;
	float* betamach;
	float* q;
	float* p;
	float utask = 100;
	float umach = 100;
	
	betamach = (float*)malloc(sizeof(float) * notask);
	betatask = (float*)malloc(sizeof(float) * nproc);
	
	ETC = (int**)malloc(sizeof(int*) * (notask));
	for(i = 0; i < notask; i++)
		ETC[i] = (int*)malloc(sizeof(int) * (nproc));
	
	if(type == 0 || type == 2 || type == 3)
	{ 
		q = (float*)malloc(sizeof(float) * (notask));
		alphatask = 1 / (Vtask[type] * Vtask[type]);
		alphamach = 1 / (Vmach[type] * Vmach[type]);
		betatask[0] = utask / alphatask;
		
		for(i = 0; i < notask; i++)
			q[i] = gengam(betatask[0],alphatask);
		
		for(i = 0; i < notask; i++)
		{
			betamach[i] = q[i]/alphamach;
			for(j = 0; j < nproc; j++)
				ETC[i][j] = (int)gengam(betamach[i],alphamach);
		} 
		
		free(q);
		
	}
	else if(type == 1)
    {
		p = (float*)malloc(sizeof(float) * nproc);
		alphatask = 1 / (Vtask[type] * Vtask[type]);
		alphamach = 1 / (Vmach[type] * Vmach[type]);
		betamach[0] = umach / alphamach;
		
		for(j = 0; j < nproc; j++)
			p[j] = gengam(betamach[0],alphamach);
		
		for(j = 0; j < nproc; j++)
		{
			betatask[j] = p[j]/alphatask;
			for(i = 0; i < notask; i++)
				ETC[i][j] = (int)gengam(betatask[j],alphatask);
		} 
		
		free(p);
    }
	
	free(betatask);
	free(betamach);
}

int main(int argc,char *argv[])
{
	int i, j, k ,l, m;
	
	char inputFileName[100];
	char outputFileName[100];
	char temp[10];
	
	const char* tmp = "_";
	
	Vtask[0] = 0.1f; Vmach[0] = 0.1f;  
	Vtask[1] = 0.1f; Vmach[1] = 0.6f;  
	Vtask[2] = 0.5f; Vmach[2] = 0.1f;  
	Vtask[3] = 0.6f; Vmach[3] = 0.6f;  
	
	int ProcType[10];
	double RCom[10];
	int VertexType[50];
	
	int noOfProcType = 0;
	int noOfRCom = 0;
	int noOfVertexType = 0;
	int noOfRandom = 20;
	
	int vertexType, procType;
	double rCom;
	
	char tchar[1000];
	int tint1, tint2;
	FILE *config = s_fopen("../configuration", "r");
	
	fscanf(config,"%s", tchar);
	tint1 = tint2 = 0;
	while(tint1 != -1)
	{
		fscanf(config,"%d %d", &tint1, &tint2);
		if(tint2 == 1){
			
			
			VertexType[noOfVertexType] = tint1;
			noOfVertexType++;  
		}
	}
	
	fscanf(config,"%s", tchar);
	tint1 = tint2 = 0;
	while(tint1 != -1)/*skipping trees*/
	{	
		fscanf(config,"%d %d", &tint1, &tint2);
	}
	
	fscanf(config,"%s", tchar);
	tint1 = tint2 = 0;
	while(tint1 != -1)
	{
		fscanf(config,"%d %d", &tint1, &tint2);
		if(tint2 == 1){
			ProcType[noOfProcType] = tint1;
			noOfProcType++;
		}
	}
	
	fscanf(config,"%s", tchar);
	double tdouble1 = 0, tdouble2 = 0;
	while(tdouble1 != -1)
	{
		fscanf(config,"%lf %lf", &tdouble1, &tdouble2);
		if(tdouble2 != -1){
			
			
			RCom[noOfRCom] = tdouble1;
			noOfRCom++;
		}
	}
	fscanf(config,"%s", tchar);
	
	fscanf(config,"%d", &noOfRandom);
	srand((unsigned)time( NULL ));
	
	for(i = 0; i < noOfVertexType; i++) //0-28
	{
		vertexType = VertexType[i];
		
		strcpy(inputFileName, "DWTPSA/dwt");
		strcat(inputFileName, tmp);	
		if(vertexType < 100)
			strcat(inputFileName, tmp);
		if(vertexType < 1000)
			strcat(inputFileName, tmp);
		
		sprintf(temp,"%d.psa", vertexType);
		strcat(inputFileName,temp);    
		
		printf("%s\n",inputFileName);
		for(j = 0; j < noOfProcType; j++)
		{
			procType = ProcType[j];
			for(k = 0; k < noOfRCom; k++)
			{
				rCom = RCom[k];
				for(l = 0; l < 4; l++)
				{
					for(m = 1; m <= noOfRandom; m++)
					{
						strcpy(outputFileName, "Data/");
						
						sprintf(temp,"dwt%d/", vertexType);
						strcat(outputFileName,temp);
						
						sprintf(temp,"t%d", vertexType);
						strcat(outputFileName,temp);
						
						sprintf(temp,"p%d", procType);
						strcat(outputFileName,temp);
						
						sprintf(temp,"r%.1f", rCom);
						strcat(outputFileName,temp);
						
						sprintf(temp,"ETC%d", l);
						strcat(outputFileName,temp);
						
						sprintf(temp,".%d", m);
						strcat(outputFileName,temp);
						
						//printf("This is the output %s\n",outputFileName); fflush(0);
						
						prog(vertexType,procType,rCom,l, inputFileName, outputFileName);
					}
				}
			}
		}
	}
	puts("Bitti bile");
	fclose(config);
	return 1;
}

int prog(int notask, int nproc, double rcom, int ETCType, char* inputFileName, char* outputFileName){
	
	graph_type TaskG;
	int *ExecT;
	int i,j,m,k;
	long int totalComm;
	double avgComp;
	float Rt;
	
	avgComp = 0;
	totalComm = 0;
	
	Read_Data(&TaskG, inputFileName);
	
	createETC(ETCType, TaskG.V, nproc);
	
	ExecT=(int *)s_malloc(sizeof(int)*(TaskG.V*nproc+1));
	
	for (i=1;i<TaskG.V;++i)
		for (m=TaskG.vlist[i].start;m<TaskG.vlist[i].end;++m)
			if (i<TaskG.elist[m].adj){
				TaskG.elist[m].wgt = Random(100)+1;
				totalComm += TaskG.elist[m].wgt;
				k=FindEdge(&TaskG,TaskG.elist[m].adj,i);
				if (k<0)
					Error_Exit("Task Graph is not symettric");
				TaskG.elist[k].wgt=TaskG.elist[m].wgt;
			}
	
	avgComp = 0;
	for (i = 0; i < TaskG.V; i++)
		for(j = 0; j < nproc; j++)
		{
			avgComp += ETC[i][j] / nproc;
			if (ETC[i][j] < 0) 
			{
				printf("Bu nasil error ETC\n");
				fflush(0);
				exit(12);
			}
			if (avgComp < 0) 
			{
				printf("Bu nasil error avgComp\n");
				fflush(0);
				exit(12);
			}
		} 
	
	
	Rt = (totalComm / avgComp) * rcom;
	
	for (i = 0; i < TaskG.V; i++)
		for(j = 0; j < nproc; j++)
		{
			ExecT[(j * TaskG.V) + i + 1] = (int)(Rt * ETC[i][j]);
			if ( ExecT[(j * TaskG.V) + i + 1] < 0) 
			{
				printf("Bu nasil error avgEXECT\n");
				fflush(0);
				exit(12);
			}
		}
	Write_Data(ExecT,&TaskG,nproc,outputFileName);
	
	free(TaskG.elist);
	free(TaskG.vlist);
	
	free(ExecT);
	for(i = 0; i < TaskG.V; i++)
		free(ETC[i]);
	free(ETC); 
}   
