#include "graph.h"
#include "util.h"

int FindRep(int *Rep,int u){

  int m,k,i=u;

  while (Rep[i]!=i)
    i=Rep[i];

  m=u;
  while (Rep[m]!=m){
	k=m;
	m=Rep[m];
	Rep[k]=i;
  } 

  return i;
}

void Cluster(int *Rep,int *TAssign,int *Rank,int u,int v){

  if (Rank[u]>Rank[v]){
    Rep[v]=u;
	TAssign[u]+=TAssign[v];
  }
  else{
    Rep[u]=v;
	TAssign[v]+=TAssign[u];
    if (Rank[u]==Rank[v])
	  ++Rank[v];
  }
}

void Lamari(int *ExecT,graph_type *TaskG,int nproc,int *Assign){

  sort_edge_type *slist;
  int i,m;
  edge_type *elist;
  vertex_type *vlist;
  int *Rep;
  int V,min,minp,sedges,ewgt;
  int repu,repv;
  int *TAssign;
  int *Rank;

  V=TaskG->V;
  elist=TaskG->elist;
  vlist=TaskG->vlist;
  
  slist=(sort_edge_type *)s_malloc(sizeof(sort_edge_type)*((TaskG->E/2)+V));
  Rep=(int *)s_malloc(sizeof(int)*(V+nproc+1));
  TAssign=(int *)s_malloc(sizeof(int)*(V+nproc+1));
  Rank=(int *)s_malloc(sizeof(int)*(V+nproc+1));  

  sedges=0;
  for (i=1;i<=V;++i)
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  if (i<elist[m].adj){
	    slist[sedges].u=i;
		slist[sedges].v=elist[m].adj;
        slist[sedges++].wgt=(nproc-1)*elist[m].wgt;
	  }
	}


  for (i=1;i<=V;++i){
    slist[sedges].wgt=ExecT[i];
	slist[sedges].u=i;
	min=ExecT[i];
	minp=1;
    for (m=2;m<=nproc;++m){
	  ewgt=ExecT[(m-1)*V+i];
	  slist[sedges].wgt+=ewgt;
	  if (min>ewgt){
	    min=ewgt;
		minp=m;
	  }
	}
	slist[sedges].wgt-=min;
	slist[sedges++].v=V+minp;
  }

  SortEdges(slist,sedges);
  
  for (i=1;i<=V;++i){
    Rank[i]=0;
    Rep[i]=i;
	TAssign[i]=0;
  }
  for (i=1;i<=nproc;++i){
    Rank[V+i]=0;
    Rep[V+i]=V+i;
	TAssign[V+i]=i;
  }

  for (i=0;i<sedges;++i){
    repu=FindRep(Rep,slist[i].u);
	repv=FindRep(Rep,slist[i].v);
	if ((repu==repv)||((TAssign[repu]>0)&&(TAssign[repv]>0)))  /* this edge does not exist */ 
	  continue;

	Cluster(Rep,TAssign,Rank,repu,repv);
  }

  for (i=1;i<=V;++i){
    Assign[i]=TAssign[FindRep(Rep,i)];
	if ((Assign[i]<=0)||(Assign[i]>nproc))
	  Error_Exit("Some Task Can't Assigned");
  }
  
  free(Rank);
  free(TAssign);
  free(Rep);
  free(slist);

}
