#include "graph.h"
#include "util.h"
#include "myheap.h"
#include "mlevel.h"

/*******Multiple Solution*********/
int MultiAssignReduce(int *ExecT,graph_type *TaskG,int *Map,int *InvMap,int *InvMapNdx,int *Assign,int nproc){

  int i,m,ptr;
  int *Assigns[5],*CAssign;
  int *Temp,*p;
  int Q[5];
  int max;
  int V;

  V=TaskG->V;
  memset(Map,0,sizeof(int)*(V+1));

  for (i=0;i<5;++i)
    Assigns[i]=(int*)s_malloc(sizeof(int)*(V+1));
  Temp=(int*)s_malloc(sizeof(int)*(V+1));
  CAssign=(int*)s_malloc(sizeof(int)*(V+1));

  for (i=0;i<5;++i){
    MlevelAssign(ExecT,TaskG,nproc,Assigns[i],CAssign,3);
	Q[i]=FindQuality(ExecT,TaskG,Assigns[i]);
  }

  max=0;
  for (i=1;i<5;++i)
    if (Q[max]<Q[i])
	  max=i;

  for (i=0;i<5;++i){
    MlevelAssign(ExecT,TaskG,nproc,Temp,CAssign,3);
	m=FindQuality(ExecT,TaskG,Temp);
	if (m<Q[max]){
	  p=Temp;
	  Temp=Assigns[max];
	  Assigns[max]=p;
	  Q[max]=m;
	  max=0;
      for (i=1;i<5;++i)
        if (Q[max]<Q[i])
	      max=i;
	}
  }
   
  ptr=0;
  for (i=1;i<=V;++i){
    for (m=1;m<5;++m)
	  if ((Assigns[m])[i]!=(Assigns[0])[i])
		break;
	if (m==5){
	  Assign[i]=Assigns[0][i];
	}
	else{
	  InvMap[ptr]=i;
	  InvMapNdx[ptr+1]=ptr;
	  ++ptr;
	  Map[i]=ptr;
	}
  }

  InvMapNdx[ptr+1]=ptr;
  
  for (i=0;i<5;++i)
    free(Assigns[i]);
  free(Temp);
  free(CAssign);

  return ptr;
}
/********End of Multiple Solution   ***********/

/*******Full agglumentative*********/

int FullFindBestNeigh(int *ExecT,graph_type *TaskG,int *Cluster,int *ClusterTree,int *BestE,int nproc,int u,int *maxval){

  int max;
  int *Cval,*Nlist;
  int nsize,i,m;
  vertex_type *vlist=TaskG->vlist;
  edge_type *elist=TaskG->elist;
  int V=TaskG->V;
  int ncluster;


  Nlist=(int *)s_malloc(sizeof(int)*(V+1));
  Cval=(int *)s_malloc(sizeof(int)*(V+1));

  memset(Cval,0,sizeof(int)*(V+1));
  Cval[u]=1;
  nsize=0;
  i=u;
  while (i!=0){
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  ncluster=Cluster[elist[m].adj];
	  if (Cval[ncluster]==0)
	    Nlist[nsize++]=ncluster;
	  Cval[ncluster]+=elist[m].wgt;
	}
	i=ClusterTree[i];
  }	  

  max=0;
  for (i=0;i<nsize;++i){
    ncluster=Nlist[i];
    Cval[ncluster]+=BestE[ncluster]+BestE[u];
	m=TogetherBestProc(ExecT,u,ncluster,nproc,V);
    Cval[ncluster]-=(ExecT[(m-1)*V+ncluster]+ExecT[(m-1)*V+u]);    
	if ((max==0)||(Cval[max]<Cval[ncluster]))
	  max=ncluster;						  
  }

  *maxval=Cval[max];
  free(Cval);
  free(Nlist);
  return max;
}

void FullMakeCluster(int *ExecT,graph_type *TaskG,pheap h,int *Cluster,int *ClusterTree,int *BestN,int *BestE,int nproc,int u,int v){

  int max;
  int *Cval,*Nlist;
  int nsize,i,m;
  vertex_type *vlist=TaskG->vlist;
  edge_type *elist=TaskG->elist;
  int V=TaskG->V;
  int ncluster;


  Nlist=(int *)s_malloc(sizeof(int)*(V+1));
  Cval=(int *)s_malloc(sizeof(int)*(V+1));
  memset(Cval,0,sizeof(int)*(V+1));
  
  i=u;
  while (ClusterTree[i]!=0)
    i=ClusterTree[i];
  ClusterTree[i]=v;
  i=v;
  while (i!=0){
    Cluster[i]=u;
	i=ClusterTree[i];
  }

  for (i=1;i<=nproc;++i){
    ExecT[(i-1)*V+u]+=ExecT[(i-1)*V+v];
	if ((ExecT[(i-1)*V+u]<BestE[u])||(i==1))
	  BestE[u]=ExecT[(i-1)*V+u];
  }

  Cval[u]=1;
  nsize=0;
  i=u;
  while (i!=0){
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  ncluster=Cluster[elist[m].adj];
	  if (Cval[ncluster]==0)
	    Nlist[nsize++]=ncluster;
	  Cval[ncluster]+=elist[m].wgt;
	}
	i=ClusterTree[i];
  }	 

  max=0;
  for (i=0;i<nsize;++i){
    ncluster=Nlist[i];
	Cval[ncluster]+=BestE[ncluster]+BestE[u];
  	m=TogetherBestProc(ExecT,u,ncluster,nproc,V);
    Cval[ncluster]-=(ExecT[(m-1)*V+ncluster]+ExecT[(m-1)*V+u]);    
	if ((max==0)||(Cval[max]<Cval[ncluster]))
	  max=ncluster;						  
  }

  BestN[u]=max;
  h->vals[u]=Cval[max];
  MaxHeapInsert(h,u);

  for (i=0;i<nsize;++i){
    ncluster=Nlist[i];
    if (h->vals[ncluster]<Cval[ncluster]){
	  BestN[ncluster]=u;
	  h->vals[ncluster]=Cval[ncluster];
	  MaxHeapIncreaseKey(h,ncluster);
	}
	else if ((BestN[ncluster]==u)||(BestN[ncluster]==v)){
	  BestN[ncluster]=FullFindBestNeigh(ExecT,TaskG,Cluster,ClusterTree,BestE,nproc,ncluster,&max);
	  MaxHeapUpdateKey(h,ncluster,max);
	}
  }

  free(Cval);
  free(Nlist);
}
int FullAggCluster(int *ExecT1,graph_type *TaskG,int *Map,int *InvMap,int *InvMapNdx,int nproc){

  int *ClusterTree,*Cluster,*BestN,*BestE,*ExecT;
  int i,k,ptr,m;
  int V;
  vertex_type *vlist;
  edge_type *elist;
  heap h;

  V=TaskG->V;
  vlist=TaskG->vlist;
  elist=TaskG->elist;

  ExecT=(int*)s_malloc(sizeof(int)*(V*nproc+1));
  memcpy(ExecT,ExecT1,sizeof(int)*(V*nproc+1));
  Cluster=(int*)s_malloc(sizeof(int)*(V+1));
  ClusterTree=(int*)s_malloc(sizeof(int)*(V+1));
  BestN=(int*)s_malloc(sizeof(int)*(V+1));
  BestE=(int*)s_malloc(sizeof(int)*(V+1));
  HeapAlloc(&h,V);

  for (i=1;i<=V;++i){
    Cluster[i]=i;
	ClusterTree[i]=0;
    BestE[i]=BestExecT(ExecT,i,nproc,V);
  }

  for (i=1;i<=V;++i){
	BestN[i]=FullFindBestNeigh(ExecT,TaskG,Cluster,ClusterTree,BestE,nproc,i,&(h.vals[i]));
    HeapAdd(&h,i);
  }
  
  MaxBuildHeap(&h);
  while ((h.size>(V/2))&&(h.vals[h.data[1]]>0)){
    i=MaxHeapExtractFirst(&h);
	if (BestN[i]!=0)
      MaxHeapDelete(&h,BestN[i]);
	FullMakeCluster(ExecT,TaskG,&h,Cluster,ClusterTree,BestN,BestE,nproc,i,BestN[i]);
  }

  ptr=0;
  k=0;
  for (i=1;i<=V;++i)
    if (Cluster[i]==i){
	  m=i;
	  ++k;
	  InvMapNdx[k]=ptr;
	  while (m!=0){
	    InvMap[ptr++]=m;
		Map[m]=k;
		m=ClusterTree[m];
	  }
	}
  InvMapNdx[k+1]=ptr;

  HeapDealloc(&h);
  free(ExecT);
  free(BestN);
  free(BestE);
  free(ClusterTree);
  return k;
}

/***end of full agglumentative****************/




/*********** Random version ***************/

int RandomFindBestNeigh(int *ExecT,graph_type *TaskG,int *Cluster,int *BestE,int nproc,int u){

  int max;
  int *Cval,*Nlist;
  int nsize,i,m;
  vertex_type *vlist=TaskG->vlist;
  edge_type *elist=TaskG->elist;
  int V=TaskG->V;
  int ncluster;


  Nlist=(int *)s_malloc(sizeof(int)*(V+1));
  Cval=(int *)s_malloc(sizeof(int)*(V+1));

  memset(Cval,0,sizeof(int)*(V+1));
  Cval[u]=1;
  nsize=0;

  for (m=vlist[u].start;m<vlist[u].end;++m){
	ncluster=Cluster[elist[m].adj];
	if (ncluster==0)
	  ncluster=elist[m].adj;
	if (Cval[ncluster]==0)
	  Nlist[nsize++]=ncluster;
	Cval[ncluster]+=elist[m].wgt;
  }

  max=0;
  for (i=0;i<nsize;++i){
    ncluster=Nlist[i];
    Cval[ncluster]+=BestE[ncluster]+BestE[u];
	m=TogetherBestProc(ExecT,u,ncluster,nproc,V);
    Cval[ncluster]-=(ExecT[(m-1)*V+ncluster]+ExecT[(m-1)*V+u]);    
	if ((i==0)||(Cval[max]<Cval[ncluster]))
	  max=ncluster;						  
  }

  free(Cval);
  free(Nlist);
  return max;
}

void RandomMakeCluster(int *ExecT,int V,int *Cluster,int *BestE,int nproc,int u,int v){

  int i;

  if (v==0)
    Cluster[u]=u;
  else{

    if (Cluster[v]==0)
      Cluster[v]=v;
    Cluster[u]=Cluster[v];

    for (i=1;i<=nproc;++i){
      ExecT[(i-1)*V+v]+=ExecT[(i-1)*V+u];
	  if ((ExecT[(i-1)*V+v]<BestE[v])||(i==1))
	    BestE[v]=ExecT[(i-1)*V+v];
    }
  }   
}




int RandomCluster(int *ExecT1,graph_type *G,int *Map,int *InvMap,int *InvMapNdx,int nproc){

  int *Cluster,*Mark,*BestE,*ExecT,*Perm;
  int i,m,k,ptr,cno,u,v;
  int V;

  V=G->V;
  ExecT=(int*)s_malloc(sizeof(int)*(V*nproc+1));
  memcpy(ExecT,ExecT1,sizeof(int)*(V*nproc+1));
  Cluster=(int*)s_malloc(sizeof(int)*(V+1));
  BestE=(int*)s_malloc(sizeof(int)*(V+1));
  Perm=(int*)s_malloc(sizeof(int)*(V+1));

  RandomPermute(Perm,V);
  for (i=1;i<=V;++i){
    Cluster[i]=0;
    BestE[i]=BestExecT(ExecT,i,nproc,V);
  }

  for (i=1;i<V;++i){
    u=Perm[i];
	if (Cluster[u]==0){
	  v=RandomFindBestNeigh(ExecT,G,Cluster,BestE,nproc,u);
	  RandomMakeCluster(ExecT,V,Cluster,BestE,nproc,u,v);
	}
  }
  
  cno=1;
  ptr=0;
  Mark=BestE;
  memset(Mark,0,sizeof(int)*(V+1));
  for (i=1;i<=V;++i){
    m=Cluster[i];
	if (Mark[m]==0){
	  InvMapNdx[cno]=ptr;
	  for (k=i;k<=V;++k)
	    if (Cluster[k]==m){
	      Map[k]=cno;
	      InvMap[ptr++]=k;
	    }
	  ++cno;
	  Mark[m]=1;
	}
  }

  InvMapNdx[cno]=ptr;
  free(Perm);
  free(ExecT);
  free(BestE);
  free(Cluster);
  return (cno-1);
}

/*End of random version*/

int MaxMatch(int *ExecT,graph_type *G,int *Map,int *InvMap,int *InvMapNdx,int nproc){
  
  sort_edge_type *slist;
  int *BestP;
  int sedges;
  edge_type *elist;
  vertex_type *vlist;
  int V;
  int i,m,u,v,bestuv,ptr;

  V=G->V;
  vlist=G->vlist;
  elist=G->elist;

  BestP=(int *)s_malloc(sizeof(int)*(V+1));
  slist=(sort_edge_type *)s_malloc(sizeof(sort_edge_type)*(G->E/2));
  memset(Map,0,sizeof(int)*(V+1));
 
  for (i=1;i<=V;++i)
    BestP[i]=BestProc(ExecT,i,nproc,V);
 
  sedges=0;
  for (i=1;i<=V;++i)
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  if (i<elist[m].adj){
	    u=slist[sedges].u=i;
		v=slist[sedges].v=elist[m].adj;
		bestuv=TogetherBestProc(ExecT,u,v,nproc,V);
        slist[sedges++].wgt=elist[m].wgt+ExecT[(BestP[u]-1)*V+u]+ExecT[(BestP[v]-1)*V+v]-
                            ExecT[(bestuv-1)*V+u]-ExecT[(bestuv-1)*V+v];
	  }
	}
  SortEdges(slist,sedges);

  m=1;
  ptr=0;
  for (i=0;i<sedges;++i){
    if (slist[i].wgt<0)
	  break;
	u=slist[i].u;
	v=slist[i].v;
	InvMapNdx[m]=ptr;
	if ((Map[u]==0)&&(Map[v]==0)){
	  InvMapNdx[m]=ptr;
	  Map[u]=m;
	  Map[v]=m;
	  InvMap[ptr++]=u;
	  InvMap[ptr++]=v;
	  ++m;
	}
  }

  for (i=1;i<=V;++i)
    if (Map[i]==0){
	  InvMapNdx[m]=ptr;
	  Map[i]=m;
	  InvMap[ptr++]=i;
	  ++m;
	}
  InvMapNdx[m]=ptr;
  free(BestP);
  return (m-1);
}

int MaxMatchWithAssign(int *ExecT,graph_type *G,int *Map,int *InvMap,int *InvMapNdx,int *Assign,int nproc){
  
  sort_edge_type *slist;
  int *BestP,*Mark;
  int sedges;
  edge_type *elist;
  vertex_type *vlist;
  int V;
  int i,m,u,v,bestuv,ptr;

  V=G->V;
  vlist=G->vlist;
  elist=G->elist;

  BestP=(int *)s_malloc(sizeof(int)*(V+1));
  Mark=(int *)s_malloc(sizeof(int)*(V+1));
  memset(Mark,0,sizeof(int)*(V+1));
  slist=(sort_edge_type *)s_malloc(sizeof(sort_edge_type)*(G->E/2));
  memset(Map,0,sizeof(int)*(V+1));
 
  for (i=1;i<=V;++i)
    BestP[i]=BestProc(ExecT,i,nproc,V);
 
  sedges=0;
  for (i=1;i<=V;++i)
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  if (i<elist[m].adj){
	    u=slist[sedges].u=i;
		v=slist[sedges].v=elist[m].adj;
		bestuv=TogetherBestProc(ExecT,u,v,nproc,V);
        slist[sedges++].wgt=elist[m].wgt+ExecT[(BestP[u]-1)*V+u]+ExecT[(BestP[v]-1)*V+v]-
                            ExecT[(bestuv-1)*V+u]-ExecT[(bestuv-1)*V+v];
	  }
	}
  SortEdges(slist,sedges);

  m=1;
  ptr=0;
  for (i=0;i<sedges;++i){
    if (slist[i].wgt<0)
	  break;
	u=slist[i].u;
	v=slist[i].v;
	Mark[u]=1;
	Mark[v]=1;
	if ((Map[u]==0)&&(Map[v]==0)){
	  Map[u]=m;
	  Map[v]=m;
	  InvMapNdx[m]=ptr; 
	  InvMap[ptr++]=u;
	  InvMap[ptr++]=v;
	  ++m;
	}
  }

  for (i=1;i<=V;++i)
    if (Map[i]==0){
	  if (Mark[i]==1){
	    Map[i]=m;
	    InvMapNdx[m]=ptr;
	    InvMap[ptr++]=i;
	    ++m;
	  }
	  else{
	    Assign[i]=BestP[i];
	  }
	}
  InvMapNdx[m]=ptr;
  free(Mark);	       
  free(BestP);
  return (m-1);
}

int AvgMatch(int *ExecT,graph_type *G,int *Map,int *InvMap,int *InvMapNdx,int *Assign,int nproc){
  
  sort_edge_type *slist;
  int *SumX;
  int sedges;
  edge_type *elist;
  vertex_type *vlist;
  int V;
  int i,m,u,v,ptr;

  V=G->V;
  vlist=G->vlist;
  elist=G->elist;

  SumX=(int *)s_malloc(sizeof(int)*(V+1));
  slist=(sort_edge_type *)s_malloc(sizeof(sort_edge_type)*((nproc*V)+(G->E/2)));
  memset(Map,0,sizeof(int)*(V+1));
 
  for (i=1;i<=V;++i){
    SumX[i]=0;
    for (m=1;m<=nproc;++m)
      SumX[i]+=ExecT[(m-1)*V+i];
  }
 
  sedges=0;
  for (i=1;i<=V;++i){
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  if (i<elist[m].adj){
	    u=slist[sedges].u=i;
		v=slist[sedges].v=elist[m].adj;
        slist[sedges++].wgt=(nproc-1)*elist[m].wgt;
	  }
	}
	for (m=1;m<=nproc;++m){
	  slist[sedges].u=i;
	  slist[sedges].v=V+m;
	  slist[sedges++].wgt=SumX[i]-(nproc*ExecT[(m-1)*V+i]);
	}
  }

  SortEdges(slist,sedges);

  m=1;
  ptr=0;
  for (i=0;i<sedges;++i){
    if (slist[i].wgt<0)
	  break;
	u=slist[i].u;
	v=slist[i].v;
	if (Map[u]==0){
	  if (v>V){
	    Assign[u]=v-V;
		Map[u]=-1;
	  }
	  else if (Map[v]==0){
  	    Map[u]=m;
	    Map[v]=m;
		InvMapNdx[m]=ptr;
	    InvMap[ptr++]=u;
	    InvMap[ptr++]=v;
	    ++m;
	  }
    }
  }

  for (i=1;i<=V;++i)
    if (Map[i]==0){
	  Map[i]=m;
	  InvMapNdx[m]=ptr;
	  InvMap[ptr++]=i;
	  ++m;
	}

  InvMapNdx[m]=ptr;
  free(SumX);
  return (m-1);
}

void RealizeMatch(mlevel_graph_type *FineG,mlevel_graph_type *CoarseG,int *Map,int nproc){
  
  int u;
  int i,m,j,k,l,VF,VC;
  edge_type *elistF,*elistC;
  vertex_type *vlistF,*vlistC;
  int *InvMap,*EW,*InvMapNdx;
  int mapu;
  int *ExecTF,*ExecTC;


  ExecTF=FineG->ExecT;
  vlistF=FineG->TaskG.vlist;
  elistF=FineG->TaskG.elist;
  VF=FineG->TaskG.V;
  VC=CoarseG->TaskG.V;
  ExecTC=CoarseG->ExecT;
  memset(ExecTC,0,sizeof(int)*(VC*nproc+1));
  vlistC=CoarseG->TaskG.vlist;
  elistC=CoarseG->TaskG.elist;
  InvMap=CoarseG->InvMap;
  InvMapNdx=CoarseG->InvMapNdx;
  
  EW=(int *)s_malloc(sizeof(int)*(VC+1));
  memset(EW,0,sizeof(int)*(VC+1));
  m=0;
  EW[0]=1;
  
  for (i=1;i<=VC;++i){
	EW[i]=1;
	vlistC[i].start=m;
	for (k=InvMapNdx[i];k<InvMapNdx[i+1];++k){
	  u=InvMap[k];
	  for (j=1;j<=nproc;++j)
	    ExecTC[(j-1)*VC+i]+=ExecTF[(j-1)*VF+u];
	  for (j=vlistF[u].start;j<vlistF[u].end;++j){
	    mapu=Map[elistF[j].adj];
	    if (mapu>0){
 	      if (EW[mapu]!=0)
	        EW[mapu]+=elistF[j].wgt;
	      else{
	        elistC[m++].adj=mapu;
		    EW[mapu]=elistF[j].wgt;
          }
	    }
	    else{	/* An Assigned Task */
	      ExecTC[(FineG->Assign[elistF[j].adj]-1)*VC+i]-=elistF[j].wgt;
		  for (l=1;l<=nproc;++l)
		    ExecTC[(l-1)*VC+i]+=elistF[j].wgt;
	    } 
	  }
	}
	vlistC[i].end=m;
	for (j=vlistC[i].start;j<vlistC[i].end;++j){
	   mapu=elistC[j].adj;
	   elistC[j].wgt=EW[mapu];
	   EW[mapu]=0;
	}
	EW[i]=0;
  }
  CoarseG->TaskG.E=m;
  free(EW);
}

/***********   Agglumentative version ********/

int AggFindBestNeigh(int *ExecT,graph_type *TaskG,int *Cluster,int *BestE,int nproc,int u,int *maxval){

  int max;
  int *Cval,*Nlist;
  int nsize,i,m;
  vertex_type *vlist=TaskG->vlist;
  edge_type *elist=TaskG->elist;
  int V=TaskG->V;
  int ncluster;


  Nlist=(int *)s_malloc(sizeof(int)*(V+1));
  Cval=(int *)s_malloc(sizeof(int)*(V+1));

  memset(Cval,0,sizeof(int)*(V+1));
  Cval[u]=1;
  nsize=0;
  for (m=vlist[u].start;m<vlist[u].end;++m){
	ncluster=Cluster[elist[m].adj];
	if (Cval[ncluster]==0)
	  Nlist[nsize++]=ncluster;
	Cval[ncluster]+=elist[m].wgt;
  }
  max=0;
  for (i=0;i<nsize;++i){
    ncluster=Nlist[i];
    Cval[ncluster]+=BestE[ncluster]+BestE[u];
	m=TogetherBestProc(ExecT,u,ncluster,nproc,V);
    Cval[ncluster]-=(ExecT[(m-1)*V+ncluster]+ExecT[(m-1)*V+u]);    
	if ((i==0)||(Cval[max]<Cval[ncluster]))
	  max=ncluster;						  
  }

  *maxval=Cval[max];
  free(Cval);
  free(Nlist);
  return max;
}
   

void AddToCluster(int *ExecT,graph_type *TaskG,pheap h,int *Cluster,int *ClusterTree,int *BestN,int *BestE,int nproc,int u,int cluster){

  int max;
  int *Cval,*Nlist;
  int nsize,i,m,k;
  vertex_type *vlist=TaskG->vlist;
  edge_type *elist=TaskG->elist;
  int V=TaskG->V;


  Nlist=(int *)s_malloc(sizeof(int)*(V+1));
  Cval=(int *)s_malloc(sizeof(int)*(V+1));
  memset(Cval,0,sizeof(int)*(V+1));
  
  i=cluster;
  while (ClusterTree[i]!=0)
    i=ClusterTree[i];
  ClusterTree[i]=u;
  Cluster[u]=cluster;

  for (i=1;i<=nproc;++i){
    ExecT[(i-1)*V+cluster]+=ExecT[(i-1)*V+u];
	if ((ExecT[(i-1)*V+cluster]<BestE[cluster])||(i==1))
	  BestE[cluster]=ExecT[(i-1)*V+cluster];
  }

  Cval[cluster]=1;
  nsize=0;
  i=cluster;
  while (i!=0){
    for (k=vlist[i].start;k<vlist[i].end;++k){
	  m=Cluster[elist[k].adj];
	  if (Cval[m]==0)
	    Nlist[nsize++]=m;
	  Cval[m]+=elist[k].wgt;
	}
	i=ClusterTree[i];
  }	 

  for (i=0;i<nsize;++i){
    m=Nlist[i];
	Cval[m]+=BestE[cluster]+BestE[m];
  	k=TogetherBestProc(ExecT,cluster,m,nproc,V);
    Cval[m]-=(ExecT[(k-1)*V+cluster]+ExecT[(k-1)*V+m]);    
  }

  for (i=0;i<nsize;++i){
    m=Nlist[i];
	if (h->ptr[m]>0){
      if (h->vals[m]<Cval[m]){
	    BestN[m]=cluster;
	    h->vals[m]=Cval[m];
	    MaxHeapIncreaseKey(h,m);
	  }
	  else if ((BestN[m]==u)||(BestN[m]==cluster)){
	    BestN[m]=AggFindBestNeigh(ExecT,TaskG,Cluster,BestE,nproc,m,&max);
	    MaxHeapUpdateKey(h,m,max);
	  }
	}
  }

  free(Cval);
  free(Nlist);
}

int MaxAggCluster(int *ExecT1,graph_type *G,int *Map,int *InvMap,int *InvMapNdx,int *Assign,int nproc){

  int *Cluster,*ClusterTree,*BestN,*BestE,*ExecT;
  int i,m,ptr,cno;
  int V;
  vertex_type *vlist;
  edge_type *elist;
  heap h;

  V=G->V;
  vlist=G->vlist;
  elist=G->elist;

  ExecT=(int*)s_malloc(sizeof(int)*(V*nproc+1));
  memcpy(ExecT,ExecT1,sizeof(int)*(V*nproc+1));
  Cluster=(int*)s_malloc(sizeof(int)*(V+1));
  ClusterTree=(int*)s_malloc(sizeof(int)*(V+1));
  BestN=(int*)s_malloc(sizeof(int)*(V+1));
  BestE=(int*)s_malloc(sizeof(int)*(V+1));
  HeapAlloc(&h,V);

  for (i=1;i<=V;++i){
    Cluster[i]=i;
	ClusterTree[i]=0;
    BestE[i]=BestExecT(ExecT,i,nproc,V);
  }

  for (i=1;i<=V;++i){
	BestN[i]=AggFindBestNeigh(ExecT,G,Cluster,BestE,nproc,i,&(h.vals[i]));
    HeapAdd(&h,i);
  }
  
  MaxBuildHeap(&h);

  i=h.data[1];
  while ((h.vals[i]>0)&&(h.size>0)){
	i=MaxHeapExtractFirst(&h);
	if (h.ptr[BestN[i]]>0)
      MaxHeapDelete(&h,BestN[i]);
	if (BestN[i]!=0)
	  AddToCluster(ExecT,G,&h,Cluster,ClusterTree,BestN,BestE,nproc,i,BestN[i]);
	i=h.data[1];
  }

  cno=1;
  ptr=0;
  for (i=1;i<=V;++i){
	if (Cluster[i]==i){
	  m=i;
	  InvMapNdx[cno]=ptr;
	  while (m!=0){
	    Map[m]=cno;
	    InvMap[ptr++]=m;
		m=ClusterTree[m];
	  }
	  ++cno;
	}
  }

  InvMapNdx[cno]=ptr;
  HeapDealloc(&h);
  free(ExecT);
  free(BestN);
  free(BestE);
  free(Cluster);
  free(ClusterTree);
  return (cno-1);
}

/***********  End of Agglumentative version **/
void Coarsen(mlevel_graph_type *FineG,mlevel_graph_type *CoarseG,int nproc,int option){
  int *Map;
  int V,E;

  
  V=FineG->TaskG.V;
  E=FineG->TaskG.E;
  
  Map=(int *)s_malloc(sizeof(int)*(V+1));
  CoarseG->InvMap=(int *)s_malloc(sizeof(int)*V);
  CoarseG->InvMapNdx=(int *)s_malloc(sizeof(int)*(V+2));
  CoarseG->ExecT=(int *)s_malloc(sizeof(int)*(V*nproc+1));
  CoarseG->TaskG.vlist=(vertex_type *)s_malloc(sizeof(vertex_type)*(V+1));
  CoarseG->TaskG.elist=(edge_type *)s_malloc(sizeof(edge_type)*E);
  CoarseG->Assign=(int *)s_malloc(sizeof(int)*(V+1));

  switch (option){
    case 1:    
      CoarseG->TaskG.V=MaxMatch(FineG->ExecT,&(FineG->TaskG),Map,CoarseG->InvMap,CoarseG->InvMapNdx,nproc);
	  break;
	case 2:
	  CoarseG->TaskG.V=MaxMatchWithAssign(FineG->ExecT,&(FineG->TaskG),Map,CoarseG->InvMap,CoarseG->InvMapNdx,FineG->Assign,nproc);
	  break;
	case 3:
	  CoarseG->TaskG.V=RandomCluster(FineG->ExecT,&(FineG->TaskG),Map,CoarseG->InvMap,CoarseG->InvMapNdx,nproc);
	  break;
	case 4:
	  CoarseG->TaskG.V=MaxAggCluster(FineG->ExecT,&(FineG->TaskG),Map,CoarseG->InvMap,CoarseG->InvMapNdx,FineG->Assign,nproc);
	  break;
	case 5:
	  CoarseG->TaskG.V=FullAggCluster(FineG->ExecT,&(FineG->TaskG),Map,CoarseG->InvMap,CoarseG->InvMapNdx,nproc);
	  break;
	case 6:
	  CoarseG->TaskG.V=MultiAssignReduce(FineG->ExecT,&(FineG->TaskG),Map,CoarseG->InvMap,CoarseG->InvMapNdx,FineG->Assign,nproc);
	  break;
  }  
  RealizeMatch(FineG,CoarseG,Map,nproc);
  free(Map);
}
