#include "graph.h"
#include "util.h"

void BfsPathFind(graph_type *G,int source,int dest,int *BfsTree,int *EdgeLoc){

  int *Fifo,fstart=0,fend=1;
  int i,m;
  vertex_type *vlist;
  edge_type *elist;

  vlist=G->vlist;
  elist=G->elist;

  Fifo=(int *)s_malloc(sizeof(int)*G->V);
  memset(BfsTree,0,sizeof(int)*(G->V+1));							 
  Fifo[0]=source;
  BfsTree[source]=-1;
  BfsTree[dest]=0;
  while ((fend>fstart)&&(BfsTree[dest]==0)){
    m=Fifo[fstart++];
	for (i=vlist[m].start;i<vlist[m].end;++i)
	  if ((elist[i].wgt>0)&&(BfsTree[elist[i].adj]==0)){
	    BfsTree[elist[i].adj]=m;
		EdgeLoc[elist[i].adj]=i;
		Fifo[fend++]=elist[i].adj;
	  }
  }
  free(Fifo);
}

void BfsAssign(graph_type *G,int source,int procno,int *Assign,int *newassigment){

  int *Fifo,fstart=0,fend=1;
  int i,m;
  int *Color;
  vertex_type *vlist;
  edge_type *elist;

  vlist=G->vlist;
  elist=G->elist;

  Fifo=(int *)s_malloc(sizeof(int)*G->V);
  Color=(int *)s_malloc(sizeof(int)*(G->V+1));
  memset(Color,0,sizeof(int)*(G->V+1));
  Fifo[0]=source;
  Color[source]=1;
  while (fend>fstart){
    m=Fifo[fstart++];
	for (i=vlist[m].start;i<vlist[m].end;++i)
	  if ((elist[i].wgt>0)&&(Color[elist[i].adj]==0)){
		if (Assign[elist[i].adj]==0){
		  *newassigment=1;
	      Assign[elist[i].adj]=procno;
		}
		else if (Assign[elist[i].adj]!=procno)
		  printf("Error Already assigned %d\n",elist[i].adj);
	    Color[elist[i].adj]=1;
		Fifo[fend++]=elist[i].adj;
	  }
  }
  free(Color);
  free(Fifo);
}

void MaxFlow(graph_type *G,int *RevE,int source,int dest,int *flowval){

  int *BfsTree;
  int *EdgeLoc;
  int m,minval,u;
  edge_type *elist;

  elist=G->elist;


  BfsTree=(int *)s_malloc(sizeof(int)*(G->V+1));
  EdgeLoc=(int *)s_malloc(sizeof(int)*(G->V+1));
  *flowval=0;
  BfsPathFind(G,source,dest,BfsTree,EdgeLoc);
  while (BfsTree[dest]!=0){
    minval=elist[EdgeLoc[dest]].wgt;
	m=BfsTree[dest];
	while (m!=source){    
      if (elist[EdgeLoc[m]].wgt<minval)
	    minval=elist[EdgeLoc[m]].wgt;
	  m=BfsTree[m];
	}
	m=dest;
	while (m!=source){
	  u=EdgeLoc[m];    
      elist[u].wgt-=minval;
	  elist[RevE[u]].wgt+=minval;
	  m=BfsTree[m];
	}
	*flowval+=minval;
	BfsPathFind(G,source,dest,BfsTree,EdgeLoc);
  }
  free(BfsTree);
  free(EdgeLoc);
}

