#include "graph.h"
#include "util.h"
#include "myheap.h"

int FindClusterToAssign(int *ExecT,graph_type *TaskG,pheap h,int *Cluster,int *ClusterTree,int *BestE,int *Assign,int nproc,int c_option){

  int cno,first=1;
  int V=TaskG->V;
  vertex_type *vlist=TaskG->vlist;
  edge_type *elist=TaskG->elist;
  int sum,adjw,i,m,k,max,myadj;

  if (c_option==1)
    cno=FindMaxHeapMin(h);
  else{
    for (i=1;i<=V;++i)
	  if (h->ptr[i]!=0){
		sum=0;
		adjw=0;
		for (m=1;m<=nproc;++m)
		  sum+=ExecT[(m-1)*V+i];
		k=i;
		while (k!=0){
		  for (m=vlist[k].start;m<vlist[k].end;++m){
		    myadj=elist[m].adj;
			if ((Assign[myadj]==0)&&(Cluster[myadj]!=i))
			  adjw+=elist[m].wgt;
		  }
		  k=ClusterTree[k];
		}
		sum=sum;
		sum-=(2*BestE[i]+adjw)*(nproc-1);
		if ((first!=0)||(sum>max)){
		  cno=i;
		  max=sum;
		  first=0;
		}
	  }
  } 		    
  return cno;

}

int FindBestNeigh(int *ExecT,graph_type *TaskG,int *Cluster,int *ClusterTree,int *BestE,int *Assign,int nproc,int u,int *maxval){

  int max;
  int *Cval,*Nlist;
  int nsize,i,m;
  vertex_type *vlist=TaskG->vlist;
  edge_type *elist=TaskG->elist;
  int V=TaskG->V;
  int ncluster;


  Nlist=(int *)s_malloc(sizeof(int)*(V+1));
  Cval=(int *)s_malloc(sizeof(int)*(V+1));

  memset(Cval,0,sizeof(int)*(V+1));
  Cval[u]=1;
  nsize=0;
  i=u;
  while (i!=0){
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  ncluster=Cluster[elist[m].adj];
	  if ((Cval[ncluster]==0)&&(Assign[ncluster]==0))
	    Nlist[nsize++]=ncluster;
	  Cval[ncluster]+=elist[m].wgt;
	}
	i=ClusterTree[i];
  }	  

  max=0;
  for (i=0;i<nsize;++i){
    ncluster=Nlist[i];
    Cval[ncluster]+=BestE[ncluster]+BestE[u];
	m=TogetherBestProc(ExecT,u,ncluster,nproc,V);
    Cval[ncluster]-=(ExecT[(m-1)*V+ncluster]+ExecT[(m-1)*V+u]);    
	if ((max==0)||(Cval[max]<Cval[ncluster]))
	  max=ncluster;						  
  }

  *maxval=Cval[max];
  free(Cval);
  free(Nlist);
  return max;
}

void AssignToBest(int *ExecT,graph_type *TaskG,pheap h,int *Cluster,int *ClusterTree,int *BestN,int *BestE,int *Assign,int nproc,int cno){
 
  int minp,i,m,myadj,temp;
  vertex_type *vlist;
  edge_type *elist;
  int V,nsize;
  int *Mark,*Nlist;

  V=TaskG->V;
  vlist=TaskG->vlist;
  elist=TaskG->elist;
  Nlist=(int *)s_malloc(sizeof(int)*(V+1));
  Mark=(int *)s_malloc(sizeof(int)*(V+1));
  memset(Mark,0,sizeof(int)*(V+1));

  minp=1;
  for (i=1;i<=nproc;++i)
    if (ExecT[(i-1)*V+cno]<ExecT[(minp-1)*V+cno])
      minp=i;
  
  nsize=0;
  m=cno;
  Mark[cno]=1;
  while (m!=0){
    Assign[m]=minp;
	for (i=vlist[m].start;i<vlist[m].end;++i){
	  myadj=Cluster[elist[i].adj];
	  if (Mark[myadj]==0){
	    Mark[myadj]=1;
		if (Assign[myadj]==0)
	      Nlist[nsize++]=myadj;
	  }
	  if ((Assign[myadj]==0)&&(myadj!=cno))
        ExecT[(minp-1)*V+myadj]-=elist[i].wgt;
	}
	m=ClusterTree[m];
  }
  for (m=0;m<nsize;++m){
    myadj=Nlist[m];
    BestE[myadj]=BestExecT(ExecT,myadj,nproc,V);
  }
  for (m=0;m<nsize;++m){
	myadj=Nlist[m];
	BestN[myadj]=FindBestNeigh(ExecT,TaskG,Cluster,ClusterTree,BestE,Assign,nproc,myadj,&temp);
    MaxHeapUpdateKey(h,myadj,temp);
  }
  free(Mark);
  free(Nlist); 
}

void MakeCluster(int *ExecT,graph_type *TaskG,pheap h,int *Cluster,int *ClusterTree,int *BestN,int *BestE,int *Assign,int nproc,int u,int v){

  int max;
  int *Cval,*Nlist;
  int nsize,i,m;
  vertex_type *vlist=TaskG->vlist;
  edge_type *elist=TaskG->elist;
  int V=TaskG->V;
  int ncluster;


  Nlist=(int *)s_malloc(sizeof(int)*(V+1));
  Cval=(int *)s_malloc(sizeof(int)*(V+1));
  memset(Cval,0,sizeof(int)*(V+1));
  
  i=u;
  while (ClusterTree[i]!=0)
    i=ClusterTree[i];
  ClusterTree[i]=v;
  i=v;
  while (i!=0){
    Cluster[i]=u;
	i=ClusterTree[i];
  }

  for (i=1;i<=nproc;++i){
    ExecT[(i-1)*V+u]+=ExecT[(i-1)*V+v];
	if ((ExecT[(i-1)*V+u]<BestE[u])||(i==1))
	  BestE[u]=ExecT[(i-1)*V+u];
  }

  Cval[u]=1;
  nsize=0;
  i=u;
  while (i!=0){
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  ncluster=Cluster[elist[m].adj];
	  if ((Cval[ncluster]==0)&&(Assign[ncluster]==0))
	    Nlist[nsize++]=ncluster;
	  Cval[ncluster]+=elist[m].wgt;
	}
	i=ClusterTree[i];
  }	 

  max=0;
  for (i=0;i<nsize;++i){
    ncluster=Nlist[i];
	Cval[ncluster]+=BestE[ncluster]+BestE[u];
  	m=TogetherBestProc(ExecT,u,ncluster,nproc,V);
    Cval[ncluster]-=(ExecT[(m-1)*V+ncluster]+ExecT[(m-1)*V+u]);    
	if ((max==0)||(Cval[max]<Cval[ncluster]))
	  max=ncluster;						  
  }

  BestN[u]=max;
  h->vals[u]=Cval[max];
  MaxHeapInsert(h,u);

  for (i=0;i<nsize;++i){
    ncluster=Nlist[i];
    if (h->vals[ncluster]<Cval[ncluster]){
	  BestN[ncluster]=u;
	  h->vals[ncluster]=Cval[ncluster];
	  MaxHeapIncreaseKey(h,ncluster);
	}
	else if ((BestN[ncluster]==u)||(BestN[ncluster]==v)){
	  BestN[ncluster]=FindBestNeigh(ExecT,TaskG,Cluster,ClusterTree,BestE,Assign,nproc,ncluster,&max);
	  MaxHeapUpdateKey(h,ncluster,max);
	}
  }

  free(Cval);
  free(Nlist);
}

void ProcEdge(int *ExecT1,graph_type *TaskG,int nproc,int *Cluster,int *Assign,int c_option){

  int *ClusterTree,*BestN,*BestE,*ExecT;
  int i;
  int V;
  vertex_type *vlist;
  edge_type *elist;
  heap h;

  V=TaskG->V;
  vlist=TaskG->vlist;
  elist=TaskG->elist;

  memset(Assign,0,sizeof(int)*(V+1));
  ExecT=(int*)s_malloc(sizeof(int)*(V*nproc+1));
  memcpy(ExecT,ExecT1,sizeof(int)*(V*nproc+1));
  ClusterTree=(int*)s_malloc(sizeof(int)*(V+1));
  BestN=(int*)s_malloc(sizeof(int)*(V+1));
  BestE=(int*)s_malloc(sizeof(int)*(V+1));
  HeapAlloc(&h,V);

  for (i=1;i<=V;++i){
    Cluster[i]=i;
	ClusterTree[i]=0;
    BestE[i]=BestExecT(ExecT,i,nproc,V);
  }

  for (i=1;i<=V;++i){
	BestN[i]=FindBestNeigh(ExecT,TaskG,Cluster,ClusterTree,BestE,Assign,nproc,i,&(h.vals[i]));
    HeapAdd(&h,i);
  }
  
  MaxBuildHeap(&h);
  while (h.size>0){
    i=MaxHeapExtractFirst(&h);
    while ((h.vals[i]>0)&&(h.size>0)){
	  if (BestN[i]!=0)
        MaxHeapDelete(&h,BestN[i]);
	  MakeCluster(ExecT,TaskG,&h,Cluster,ClusterTree,BestN,BestE,Assign,nproc,i,BestN[i]);
	  i=MaxHeapExtractFirst(&h);
    }
    MaxHeapInsert(&h,i);
	i=FindClusterToAssign(ExecT,TaskG,&h,Cluster,ClusterTree,BestE,Assign,nproc,c_option);
	MaxHeapDelete(&h,i);
	AssignToBest(ExecT,TaskG,&h,Cluster,ClusterTree,BestN,BestE,Assign,nproc,i);
  }
  
  HeapDealloc(&h);
  free(ExecT);
  free(BestN);
  free(BestE);
  free(ClusterTree);
}
