#include "graph.h"
#include "util.h"
#include "myheap.h"



int RefinePass(int *ExecT,graph_type *TaskG,int *Assign,int nproc){

  int *Gain,*Moves,*MoveGains,*MaxProc;
  int V;
  vertex_type *vlist;
  edge_type *elist;
  int i,m,k,myadj,myp,hisp,newp;
  heap h;
  int temp,p;
  int maxp,maxwgt;


  V=TaskG->V;
  vlist=TaskG->vlist;
  elist=TaskG->elist;


  Moves=(int *)s_malloc(sizeof(int)*V);
  MoveGains=(int *)s_malloc(sizeof(int)*V);
  Gain=(int *)s_malloc(sizeof(int)*(V*nproc+1));
  MaxProc=(int *)s_malloc(sizeof(int)*(V+1));
  
  memset(Gain,0,sizeof(int)*(V*nproc+1));
  HeapAlloc(&h,V);
  

  /*Gain Computation */

  for (i=1;i<=V;++i){
    myp=Assign[i];
    temp=ExecT[(myp-1)*V+i];
	for (m=vlist[i].start;m<vlist[i].end;++m){
	  hisp=Assign[elist[m].adj];
	  Gain[(i-1)*nproc+hisp]+=elist[m].wgt;
	}
	temp-=Gain[(i-1)*nproc+myp];
	for (m=1;m<=nproc;++m)
	  Gain[(i-1)*nproc+m]+=temp-ExecT[(m-1)*V+i];
  }
  
  /* Fill the heap */

  for (i=1;i<=V;++i){
   	myp=Assign[i];
	maxp=0;
    for (m=1;m<=nproc;++m)
	  if (m!=myp){
	    temp=Gain[(i-1)*nproc+m];
        if ((maxp==0)||(maxwgt<temp)){
		  maxp=m;
		  maxwgt=temp;
		}
	  }
	h.vals[i]=maxwgt;
	MaxProc[i]=maxp;
	HeapAdd(&h,i);
  }

  MaxBuildHeap(&h);
  k=0;
  while (!IsHeapEmpty(&h)){
    i=MaxHeapExtractFirst(&h);
	Moves[k]=i;
	MoveGains[k++]=h.vals[i];
	/* Make Updates */
	myp=Assign[i];
	newp=MaxProc[i];
  	for (m=vlist[i].start;m<vlist[i].end;++m){
	  myadj=elist[m].adj;
	  hisp=Assign[myadj];
	  if (IsInHeap(&h,myadj)){
	    if (hisp==myp){
		  for (p=1;p<=nproc;++p)
		    Gain[(myadj-1)*nproc+p]+=elist[m].wgt;
		  Gain[(myadj-1)*nproc+newp]+=elist[m].wgt;
		  temp=Gain[(myadj-1)*nproc+newp];
		  h.vals[myadj]=Gain[(myadj-1)*nproc+MaxProc[myadj]];
		  if (temp>h.vals[myadj]){
		    h.vals[myadj]=temp;
			MaxProc[myadj]=newp;
		  }
		  MaxHeapIncreaseKey(&h,myadj);
		}
		else if (hisp==newp){
		  for (p=1;p<=nproc;++p)
		    Gain[(myadj-1)*nproc+p]-=elist[m].wgt;
		  Gain[(myadj-1)*nproc+myp]-=elist[m].wgt;
		  if (MaxProc[myadj]==myp){
  		    maxp=0;
            for (p=1;p<=nproc;++p)
	          if (p!=hisp){
	            temp=Gain[(myadj-1)*nproc+p];
                if ((maxp==0)||(maxwgt<temp)){
		          maxp=p;
		          maxwgt=temp;
		        }
	        }
	        h.vals[myadj]=maxwgt;
	        MaxProc[myadj]=maxp;
		  }
		  else
		    h.vals[myadj]=Gain[(myadj-1)*nproc+MaxProc[myadj]];
		  MaxHeapDecreaseKey(&h,myadj);
		}
		else{
		  Gain[(myadj-1)*nproc+newp]+=elist[m].wgt;
		  Gain[(myadj-1)*nproc+myp]-=elist[m].wgt;
		  temp=Gain[(myadj-1)*nproc+newp];
		  if (MaxProc[myadj]==myp){
		    maxp=0;
            for (p=1;p<=nproc;++p)
	          if (p!=hisp){
	            temp=Gain[(myadj-1)*nproc+p];
                if ((maxp==0)||(maxwgt<temp)){
		          maxp=p;
		          maxwgt=temp;
		        }
	        }
	     	MaxHeapUpdateKey(&h,myadj,maxwgt);
	        MaxProc[myadj]=maxp;
		  }
		  else if  (temp>h.vals[myadj]){
		    MaxProc[myadj]=newp;
		    h.vals[myadj]=temp;
		    MaxHeapIncreaseKey(&h,myadj);
		  }
		}     
	  } 
  	}
  }
  for (i=1;i<V;++i)
    MoveGains[i]+=MoveGains[i-1];
  maxwgt=0;
  for (i=0;i<V;++i)
    if (MoveGains[i]>maxwgt){
	  maxwgt=MoveGains[i];
	  maxp=i;
	}
  if (maxwgt>0){
    for (i=0;i<=maxp;++i)
	  Assign[Moves[i]]=MaxProc[Moves[i]];
  }

  free(MaxProc);
  free(Moves);
  free(MoveGains);
  free(Gain);
  HeapDealloc(&h);
  return maxwgt;
}

void Refine(int *ExecT,graph_type *TaskG,int *Assign,int nproc){

  int i=0;

  while ((i<20)&&(RefinePass(ExecT,TaskG,Assign,nproc)>0))
    ++i;
}

void VmlRefine(int *ExecT1,graph_type *TaskG,int *Fixed,int *Assign,int nproc){

  int *ExecT,*TAssign,*Perm;
  graph_type TmG;
  int i,m,newv,V,myadj,ewgt,ptr,k,myid;
  vertex_type *vlist1,*vlist2;
  edge_type *elist1,*elist2;



  V=TaskG->V;
  ExecT=(int *)s_malloc(sizeof(int)*(V*nproc+1));
  TAssign=(int *)s_malloc(sizeof(int)*(V+1));
  Perm=(int *)s_malloc(sizeof(int)*(V+1));
  memset(Perm,0,sizeof(int)*(V+1));

  newv=0;  
  for (i=1;i<=V;++i){
    if (Fixed[i]==0){ 
	  ++newv;
	  Perm[i]=newv;
	  TAssign[newv]=Assign[i];
	}
  }

  for (i=1;i<=V;++i)
    if (Fixed[i]==0){
	  myid=Perm[i]; 
  	  for (m=1;m<=nproc;++m)
	    ExecT[(m-1)*newv+myid]=ExecT1[(m-1)*V+i];
	}

  TmG.V=newv;
  TmG.E=TaskG->E;
  AllocateGraph(&TmG);

  vlist1=TmG.vlist;
  elist1=TmG.elist;
  vlist2=TaskG->vlist;
  elist2=TaskG->elist;

  ptr=0;
  for (i=1;i<=V;++i)
    if (Fixed[i]==0){
      myid=Perm[i];
	  vlist1[myid].start=ptr;
	  for (m=vlist2[i].start;m<vlist2[i].end;++m){
	    myadj=elist2[m].adj;
	    ewgt=elist2[m].wgt;
	    if (Fixed[myadj]!=0){
	      ExecT[(Assign[myadj]-1)*newv+myid]-=ewgt;
	      for (k=1;k<=nproc;++k)
	        ExecT[(k-1)*newv+myid]+=ewgt;
	    }
	    else{
	      elist1[ptr].adj=Perm[myadj];
	      elist1[ptr++].wgt=ewgt;
	    }
	  }
	  vlist1[myid].end=ptr;
	}
  TmG.E=ptr;
  Refine(ExecT,&TmG,TAssign,nproc);
  for (i=1;i<=V;++i){
    if (Fixed[i]==0)
	  Assign[i]=TAssign[Perm[i]];
  }
  free(Perm);
  free(TAssign);
  free(ExecT);
  FreeGraph(&TmG);
}

void TwoLevelRefine(int *ExecT1,graph_type *TaskG,int *Cluster,int *Assign,int nproc){

  int *ExecT,*TAssign,*Cval;
  graph_type TmG;
  int i,m,V,ptr,k,myadj,ncluster,mycluster;
  vertex_type *vlist1,*vlist2;
  edge_type *elist1,*elist2;



  V=TaskG->V;
  ExecT=(int *)s_malloc(sizeof(int)*(V*nproc+1));
  memset(ExecT,0,sizeof(int)*(V*nproc+1));
  TAssign=(int *)s_malloc(sizeof(int)*(V+1));
  memset(TAssign,0,sizeof(int)*(V+1));
  Cval=(int *)s_malloc(sizeof(int)*(V+1));
  memset(Cval,0,sizeof(int)*(V+1));

  ncluster=0;  
  for (i=1;i<=V;++i){
    mycluster=Cluster[i];
	if (TAssign[mycluster]==0){
	  ++ncluster;
	  TAssign[mycluster]=ncluster;
	}
  }
  for (i=1;i<=V;++i){
    Cluster[i]=TAssign[Cluster[i]];
  }

  TmG.V=ncluster;
  TmG.E=TaskG->E;
  AllocateGraph(&TmG);

  vlist1=TmG.vlist;
  elist1=TmG.elist;
  vlist2=TaskG->vlist;
  elist2=TaskG->elist;

  ptr=0;
  for (i=1;i<=ncluster;++i){
    Cval[i]=1;
    vlist1[i].start=ptr;
    for (m=1;m<=V;++m)
	  if (Cluster[m]==i){
	    TAssign[i]=Assign[m];
		for (k=1;k<=nproc;++k)
		  ExecT[(k-1)*ncluster+i]+=ExecT1[(k-1)*V+m];
	    for (k=vlist2[m].start;k<vlist2[m].end;++k){
	      myadj=Cluster[elist2[k].adj];
	      if (Cval[myadj]==0)
		    elist1[ptr++].adj=myadj;
		  Cval[myadj]+=elist2[k].wgt;
		}
	  }
	vlist1[i].end=ptr;
	Cval[i]=0;
	for (m=vlist1[i].start;m<vlist1[i].end;++m){
	  myadj=elist1[m].adj;
	  elist1[m].wgt=Cval[myadj];
	  Cval[myadj]=0;
	}
  }

  TmG.E=ptr;
  Refine(ExecT,&TmG,TAssign,nproc);
  for (i=1;i<=V;++i){
	Assign[i]=TAssign[Cluster[i]];
  }
  Refine(ExecT1,TaskG,Assign,nproc);
  free(Cval);
  free(TAssign);
  free(ExecT);
  FreeGraph(&TmG);
}
   	           
	   
	    
