#include "graph.h"
#include "util.h"
#include "mincut.h"
#include "vml.h"
#include "lamari.h"
#include "mylamari.h"
#include "procedge.h"
#include "refine.h"
#include "mlevel.h"
#include "twinass.h"
 
void main(int argc,char *argv[]){

  int i;		   
  graph_type TaskG;
  int *ExecT;
  int *Assign,*Fixed,*Cluster;
  int nproc,optval;
  double T[10],start,end;

  if (argc==2){
    Read_Data(&ExecT,&TaskG,&nproc,&optval,argv[1]);
    Assign=(int *)s_malloc(sizeof(int)*(TaskG.V+1));
    Cluster=(int *)s_malloc(sizeof(int)*(TaskG.V+1));
    Fixed=(int *)s_malloc(sizeof(int)*(TaskG.V+1));    
    
    start=GetSeconds();
    Vml(ExecT,&TaskG,nproc,Fixed,Assign);
    VmlRefine(ExecT,&TaskG,Fixed,Assign,nproc);
	end=GetSeconds();
	T[1]=end-start;

    start=GetSeconds();
    Lamari(ExecT,&TaskG,nproc,Assign);
    Refine(ExecT,&TaskG,Assign,nproc);
    end=GetSeconds();
	T[2]=end-start;


	start=GetSeconds();
    MyLamari(ExecT,&TaskG,nproc,Assign);
    Refine(ExecT,&TaskG,Assign,nproc);
    end=GetSeconds();
	T[3]=end-start;
    
    start=GetSeconds();
    ProcEdge(ExecT,&TaskG,nproc,Cluster,Assign);
    TwoLevelRefine(ExecT,&TaskG,Cluster,Assign,nproc);
    end=GetSeconds();
	T[4]=end-start;
    
    start=GetSeconds();
    TwinAssign(ExecT,&TaskG,nproc,Cluster,Assign);
    TwoLevelRefine(ExecT,&TaskG,Cluster,Assign,nproc);
    end=GetSeconds();
	T[5]=end-start;
    
	start=GetSeconds();
    MlevelAssign(ExecT,&TaskG,nproc,Assign,1);
    end=GetSeconds();
	T[6]=end-start;
    
	start=GetSeconds();
    MlevelAssign(ExecT,&TaskG,nproc,Assign,4);
    end=GetSeconds();
	T[7]=end-start;
    
    start=GetSeconds();
    MlevelAssign(ExecT,&TaskG,nproc,Assign,5);
    end=GetSeconds();
	T[8]=end-start;
    
    start=GetSeconds();
    MlevelAssign(ExecT,&TaskG,nproc,Assign,6);
    end=GetSeconds();
	T[9]=end-start;
  
    for (i=1;i<=9;++i)
      T[i]=T[i]/T[3];
    
    for (i=1;i<=9;++i)
      printf("\t%2.2f",T[i]);
    printf("\n");

  }
  else{
    printf("Usage  : %s <Data File>\n",argv[0]);
    exit(1);
  } 
}   






