#include "timer.h"

void u_cleartimer(ptimer tmr)
{
tmr->time = 0.0;
tmr->count = 0L;
tmr->status = TMR_CLEAR;
}

void u_addtimer(ptimer t, ptimer a)
{
t->time += a->time;
t->count++;
}

void u_starttimer(ptimer tmr)
{
if (tmr->status == TMR_START) 
     {
	printf("Timer already started!\n");
	exit(1);
     }
   
tmr->time -= u_seconds();
tmr->count++;
tmr->status = TMR_START;
}


void u_stoptimer(ptimer tmr)
{
if (tmr->status != TMR_START) 
     {
	printf("Timer has not been started!\n");
	exit(1);
     }
   
tmr->time += u_seconds();
tmr->status = TMR_STOP;
}


void u_printtimer(ptimer tmr, char *msg)
{
if (tmr->status == TMR_START) 
     {
	printf("Timing is in progress!\n");
	exit(1);
     }
   
printf("%s: %11.3lf seconds", msg, tmr->time);
fflush(stdout);
}

double u_gettimer(ptimer tmr)
{
if (tmr->status == TMR_START) 
     {	
	printf("Timing is in progress!\n");
	exit(1);
     }
   
return tmr->time;
}

char *u_gettimestr(ptimer tmr)
{
static char st[20];
double h, m, s;


if (tmr->status == TMR_START) 
     {
	
	printf("Timing is in progress!\n");
	exit(12);
     }
   
m = tmr->time / 60.0;
s = tmr->time - (int)m*60;
h = m / 60.0;
m = m - (int)h*60;

sprintf(st, "%d:%02d:%02d", (int) h, (int) m, (int) s);
return st;
}


double u_seconds(void)
{

return((double) clock()*1.0e-6);

}



