#ifndef _TIMER_H
#define _TIMER_H  

#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <stdarg.h>
#include <fcntl.h>


#define TMR_CLEAR   1
#define TMR_START   2
#define TMR_STOP    8


  struct timer 
    {
    int    status;    /* current status of timer look TMR_xxxx constants */
    double time;      /* time in seconds */
    long   count;     /* counts how many times the counter was started */
    };

typedef struct timer    timer;
typedef timer           *ptimer;

void u_cleartimer(ptimer);
void u_starttimer(ptimer);
void u_addtimer(ptimer t, ptimer a);
void u_stoptimer(ptimer);
void u_printtimer(ptimer, char *msg);
char *u_gettimestr(ptimer tmr);
double u_gettimer(ptimer);
double u_seconds(void);



#endif

