#include "graph.h"
#include "util.h"
#include "myheap.h"

int TreeBestProc(int *ExecT,int u1,int u2,int u3,int nproc,int V){

  int i;
  int minp,mine,temp;
    
  for (i=1;i<=nproc;++i){
    temp=ExecT[(i-1)*V+u1]+ExecT[(i-1)*V+u2]+ExecT[(i-1)*V+u3];
    if ((temp<mine)||(i==1)){
      minp=i;
      mine=temp;
    }
  }
  return minp;
}

int ClusterEdgeWgt(graph_type *TaskG,int *Cluster,int *ClusterTree,int source,int dest){

  int i,m,myadj,wgt;
  edge_type *elist;
  vertex_type *vlist;

  
  vlist=TaskG->vlist;
  elist=TaskG->elist;

  wgt=0;
  i=source;
  while (i!=0){
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  myadj=Cluster[elist[m].adj];
	  if (myadj==dest)
	    wgt+=elist[m].wgt;
	}
	i=ClusterTree[i];
  }
  return wgt;
}
    
int TwinFindOneBestNeigh(int *ExecT,graph_type *TaskG,int *Cluster,int *ClusterTree,int *BestE,int *Assign,int nproc,int u,int n1,int *n2){

  int maxwgt,temp;
  int *Cval,*Nlist;
  int nsize,i,m,k;
  vertex_type *vlist=TaskG->vlist;
  edge_type *elist=TaskG->elist;
  int V=TaskG->V;
  int myadj;


  Nlist=(int *)s_malloc(sizeof(int)*(V+1));
  Cval=(int *)s_malloc(sizeof(int)*(V+1));

  memset(Cval,0,sizeof(int)*(V+1));
  Cval[u]=1;
  nsize=0;
  i=u;
  while (i!=0){
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  myadj=Cluster[elist[m].adj];
	  if ((Cval[myadj]==0)&&(Assign[myadj]==0))
	    Nlist[nsize++]=myadj;
	  Cval[myadj]+=elist[m].wgt;
	}
	i=ClusterTree[i];
  }	  

  *n2=0;
  m=TogetherBestProc(ExecT,u,n1,nproc,V);
  maxwgt=Cval[n1]+BestE[u]+BestE[n1]-ExecT[(m-1)*V+u]-ExecT[(m-1)*V+n1];
  if (nsize>1){
	for (i=0;i<nsize;++i){
	  myadj=Nlist[i];
	  if (myadj!=n1){
	    temp=Cval[n1]+Cval[myadj]+BestE[u]+BestE[n1]+BestE[myadj]+ClusterEdgeWgt(TaskG,Cluster,ClusterTree,n1,myadj); 	    
		k=TreeBestProc(ExecT,u,n1,myadj,nproc,V);
		temp-=(ExecT[(k-1)*V+u]+ExecT[(k-1)*V+n1]+ExecT[(k-1)*V+myadj]);
		if (temp>maxwgt){
		  maxwgt=temp;
		  *n2=myadj;
		}
	  }
	}
  }
  free(Cval);
  free(Nlist);
  return maxwgt;
}

int TwinFindBestNeighs(int *ExecT,graph_type *TaskG,int *Cluster,int *ClusterTree,int *BestE,int *Assign,int nproc,int u,int *n1,int *n2){

  int maxwgt,temp;
  int *Cval,*Nlist;
  int nsize,i,m,k;
  vertex_type *vlist=TaskG->vlist;
  edge_type *elist=TaskG->elist;
  int V=TaskG->V;
  int myadj1,myadj2;


  Nlist=(int *)s_malloc(sizeof(int)*(V+1));
  Cval=(int *)s_malloc(sizeof(int)*(V+1));

  memset(Cval,0,sizeof(int)*(V+1));
  Cval[u]=1;
  nsize=0;
  i=u;
  while (i!=0){
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  myadj1=Cluster[elist[m].adj];
	  if ((Cval[myadj1]==0)&&(Assign[myadj1]==0))
	    Nlist[nsize++]=myadj1;
	  Cval[myadj1]+=elist[m].wgt;
	}
	i=ClusterTree[i];
  }	  
   
  maxwgt=0;
  *n1=0;
  *n2=0;
  for (i=0;i<nsize;++i){
    myadj1=Nlist[i];
    temp=Cval[myadj1]+BestE[myadj1]+BestE[u];
	m=TogetherBestProc(ExecT,u,myadj1,nproc,V);
    temp-=(ExecT[(m-1)*V+myadj1]+ExecT[(m-1)*V+u]);    
	if ((i==0)||(maxwgt<temp)){
	  *n1=myadj1;
	  maxwgt=temp;
	}  						  
  }

  if (nsize>1){
	for (i=0;i<nsize;++i){
	  myadj1=Nlist[i];
	  temp=Cval[myadj1]+BestE[u]+BestE[myadj1]; 
	  for (m=i+1;m<nsize;++m){
	    myadj2=Nlist[m];
		temp+=ClusterEdgeWgt(TaskG,Cluster,ClusterTree,myadj1,myadj2)+Cval[myadj2]+BestE[myadj2];
		k=TreeBestProc(ExecT,u,myadj1,myadj2,nproc,V);
		temp-=(ExecT[(k-1)*V+u]+ExecT[(k-1)*V+myadj1]+ExecT[(k-1)*V+myadj2]);
		if (temp>maxwgt){
		  maxwgt=temp;
		  *n1=myadj1;
		  *n2=myadj2;
		}
	  }
	}
  }
  free(Cval);
  free(Nlist);
  return maxwgt;
}

void TwinAssignToBest(int *ExecT,graph_type *TaskG,pheap h,int *Cluster,int *ClusterTree,int *N1,int *N2,int *BestE,int *Assign,int nproc,int cno){
 
  int minp,i,m,myadj,temp;
  vertex_type *vlist;
  edge_type *elist;
  int V,nsize;
  int *Mark,*Nlist;

  V=TaskG->V;
  vlist=TaskG->vlist;
  elist=TaskG->elist;
  Nlist=(int *)s_malloc(sizeof(int)*(V+1));
  Mark=(int *)s_malloc(sizeof(int)*(V+1));
  memset(Mark,0,sizeof(int)*(V+1));

  minp=BestProc(ExecT,cno,nproc,V);

  nsize=0;
  m=cno;
  Mark[cno]=1;
  
  while (m!=0){
    Assign[m]=minp;
	for (i=vlist[m].start;i<vlist[m].end;++i){
	  myadj=Cluster[elist[i].adj];
	  if (Mark[myadj]==0){
	    Mark[myadj]=1;
		if (Assign[myadj]==0)
	      Nlist[nsize++]=myadj;
	  }
	  if ((Assign[myadj]==0)&&(myadj!=cno))
        ExecT[(minp-1)*V+myadj]-=elist[i].wgt;
	}
	m=ClusterTree[m];
  }
  
  for (m=0;m<nsize;++m){
    myadj=Nlist[m];
    BestE[myadj]=BestExecT(ExecT,myadj,nproc,V);
  }
  for (m=0;m<nsize;++m){
	myadj=Nlist[m];
	temp=TwinFindBestNeighs(ExecT,TaskG,Cluster,ClusterTree,BestE,Assign,nproc,myadj,&(N1[myadj]),&(N2[myadj]));
    MaxHeapUpdateKey(h,myadj,temp);
  }
  free(Mark);
  free(Nlist); 
}

void TwinMakeCluster(int *ExecT,graph_type *TaskG,pheap h,int *Cluster,int *ClusterTree,int *N1,int *N2,int *BestE,int *Assign,int nproc,int u){

  int n1,n2,temp;
  int *Mark;
  int i,m,k;
  vertex_type *vlist=TaskG->vlist;
  edge_type *elist=TaskG->elist;
  int V=TaskG->V;
  int ncluster;


  Mark=(int *)s_malloc(sizeof(int)*(V+1));
  memset(Mark,0,sizeof(int)*(V+1));

  n1=N1[u];
  n2=N2[u];
  
  i=u;
  while (ClusterTree[i]!=0)
    i=ClusterTree[i];
  ClusterTree[i]=n1;
  i=n1;
  while (ClusterTree[i]!=0){
    Cluster[i]=u;
	i=ClusterTree[i];
  }
  Cluster[i]=u;
  ClusterTree[i]=n2;
  i=n2;
  while (i!=0){
    Cluster[i]=u;
	i=ClusterTree[i];
  }
 

  for (i=1;i<=nproc;++i){
    ExecT[(i-1)*V+u]+=ExecT[(i-1)*V+n1];
	if (n2!=0)
      ExecT[(i-1)*V+u]+=ExecT[(i-1)*V+n2];	  
	if ((ExecT[(i-1)*V+u]<BestE[u])||(i==1))
	  BestE[u]=ExecT[(i-1)*V+u];
  }

  h->vals[u]=TwinFindBestNeighs(ExecT,TaskG,Cluster,ClusterTree,BestE,Assign,nproc,u,&N1[u],&N2[u]);
  MaxHeapInsert(h,u);
  i=u;
  Mark[u]=1;
  while (i!=0){
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  ncluster=Cluster[elist[m].adj];
	  if (Mark[ncluster]==0){
	    if (Assign[ncluster]==0){
	      if ((N1[ncluster]==u)||(N1[ncluster]==n1)||(N1[ncluster]==n2)||(N2[ncluster]==u)||(N2[ncluster]==n1)||(N2[ncluster]==n2)){
	        temp=TwinFindBestNeighs(ExecT,TaskG,Cluster,ClusterTree,BestE,Assign,nproc,ncluster,&N1[ncluster],&N2[ncluster]);
	 	    MaxHeapUpdateKey(h,ncluster,temp);
		  }
		  else{
		    temp=TwinFindOneBestNeigh(ExecT,TaskG,Cluster,ClusterTree,BestE,Assign,nproc,ncluster,u,&k);
		    if (temp>h->vals[ncluster]){
		      h->vals[ncluster]=temp;
		      MaxHeapIncreaseKey(h,ncluster);
			  N1[ncluster]=u;
			  N2[ncluster]=k;
		    }
		  }
		}   
		Mark[ncluster]=1;
	  }
	}
	i=ClusterTree[i];
  }
  free(Mark);
}

void TwinAssign(int *ExecT1,graph_type *TaskG1,int nproc,int *Cluster,int *Assign){

  int *ClusterTree,*N1,*N2,*BestE,*ExecT;
  graph_type TaskG;
  int i;
  int V;
  vertex_type *vlist;
  edge_type *elist;
  heap h;

  V=TaskG1->V;
  memset(Assign,0,sizeof(int)*(V+1));
  ExecT=(int*)s_malloc(sizeof(int)*(V*nproc+1));
  memcpy(ExecT,ExecT1,sizeof(int)*(V*nproc+1));
  ClusterTree=(int*)s_malloc(sizeof(int)*(V+1));
  N1=(int*)s_malloc(sizeof(int)*(V+1));
  N2=(int*)s_malloc(sizeof(int)*(V+1));
  BestE=(int*)s_malloc(sizeof(int)*(V+1));
  HeapAlloc(&h,V);

  TaskG.V=V;
  TaskG.E=TaskG1->E;
  AllocateGraph(&TaskG);
  vlist=TaskG.vlist;
  elist=TaskG.elist;
  memcpy(vlist,TaskG1->vlist,sizeof(vertex_type)*(V+1));
  memcpy(elist,TaskG1->elist,sizeof(edge_type)*(TaskG.E));

  for (i=1;i<=V;++i){
    Cluster[i]=i;
	ClusterTree[i]=0;
    BestE[i]=BestExecT(ExecT,i,nproc,V);
  }

  for (i=1;i<=V;++i){
	h.vals[i]=TwinFindBestNeighs(ExecT,&TaskG,Cluster,ClusterTree,BestE,Assign,nproc,i,&(N1[i]),&(N2[i]));
    HeapAdd(&h,i);
  }
  
  MaxBuildHeap(&h);
  while (h.size>0){
    i=MaxHeapExtractFirst(&h);
    while (h.vals[i]>0){
      MaxHeapDelete(&h,N1[i]);
	  if (N2[i]!=0)
        MaxHeapDelete(&h,N2[i]);
	  TwinMakeCluster(ExecT,&TaskG,&h,Cluster,ClusterTree,N1,N2,BestE,Assign,nproc,i);
	  i=MaxHeapExtractFirst(&h);
    }
    MaxHeapInsert(&h,i);
	i=FindMaxHeapMin(&h);
	MaxHeapDelete(&h,i);
    TwinAssignToBest(ExecT,&TaskG,&h,Cluster,ClusterTree,N1,N2,BestE,Assign,nproc,i);
  }
  
  free(ExecT);
  free(N1);
  free(N2);
  free(BestE);
  free(ClusterTree);
  HeapDealloc(&h);
  FreeGraph(&TaskG);
}
