#include "graph.h"
#include "util.h"
#include "myheap.h"

int FindHeapMin(pheap h){
  int i,u,min;

  min=h->data[1];
  for (i=(h->size+1)/2;i<=h->size;++i){
    u=h->data[i];
	if (h->vals[min]>h->vals[u])
	  min=u;
  }

  return min;
}
    
int TwinFindBestNeigh(int *ExecT,graph_type *TaskG,int *Cluster,int *ClusterTree,int *BestE,int nproc,int u,int *maxval){

  int max;
  int *Cval,*Nlist;
  int nsize,i,m;
  vertex_type *vlist=TaskG->vlist;
  edge_type *elist=TaskG->elist;
  int V=TaskG->V;
  int ncluster;


  Nlist=(int *)s_malloc(sizeof(int)*(V+1));
  Cval=(int *)s_malloc(sizeof(int)*(V+1));

  memset(Cval,0,sizeof(int)*(V+1));
  Cval[u]=1;
  nsize=0;
  i=u;
  while (i!=0){
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  ncluster=Cluster[elist[m].adj];
	  if (Cval[ncluster]==0)
	    Nlist[nsize++]=ncluster;
	  Cval[ncluster]+=elist[m].wgt;
	}
	i=ClusterTree[i];
  }	  
  max=0;
  for (i=0;i<nsize;++i){
    ncluster=Nlist[i];
    Cval[ncluster]+=BestE[ncluster]+BestE[u];
	m=TogetherBestProc(ExecT,u,ncluster,nproc,V);
    Cval[ncluster]-=(ExecT[(m-1)*V+ncluster]+ExecT[(m-1)*V+u]);    
	if ((max==0)||(Cval[max]<Cval[ncluster]))
	  max=ncluster;						  
  }

  *maxval=Cval[max];
  free(Cval);
  free(Nlist);
  return max;
}

void TwinAssignCluster(int *ExecT,graph_type *TaskG,pheap h,int *Cluster,int *ClusterTree,int *BestN,int *BestE,int nproc,int cno,int *Assign){
 
   int bestp,i,m,myadj,temp;
   int *Mark;
   vertex_type *vlist;
   edge_type *elist;
   int V;

   V=TaskG->V;
   vlist=TaskG->vlist;
   elist=TaskG->elist;

   m=cno;
   bestp=BestProc(ExecT,m,nproc,V);
   while (m!=0){
     Assign[m]=bestp;
	 m=ClusterTree[m];
   }
   m=cno;
   while (m!=0){
	 for (i=vlist[m].start;i<vlist[m].end;++i){
	   myadj=elist[i].adj;
	   ExecT[(bestp-1)*V+Cluster[myadj]]-=elist[i].adj;
	   DeleteEdge(TaskG,myadj,m);
	 }
	 m=ClusterTree[m];
   }
   
   Mark=(int *)s_malloc(sizeof(int)*(V+1));
   memset(Mark,0,sizeof(int)*(V+1));
   m=cno;
   while (m!=0){
	 for (i=vlist[m].start;i<vlist[m].end;++i){
	   myadj=Cluster[elist[i].adj];
	   if (Mark[myadj]==0){
	     bestp=BestProc(ExecT,myadj,nproc,V);
		 BestE[myadj]=ExecT[(bestp-1)*V+myadj];
		 BestN[myadj]=TwinFindBestNeigh(ExecT,TaskG,Cluster,ClusterTree,BestE,nproc,myadj,&temp);
		 MaxHeapUpdateKey(h,myadj,temp);
		 Mark[myadj]=1;
	   }  
	 }
	 m=ClusterTree[m];
   }
   free(Mark);
}
   

void TwinMakeCluster(int *ExecT,graph_type *TaskG,pheap h,int *Cluster,int *ClusterTree,int *BestN,int *BestE,int nproc,int u,int v){

  int max;
  int *Cval,*Nlist;
  int nsize,i,m;
  vertex_type *vlist=TaskG->vlist;
  edge_type *elist=TaskG->elist;
  int V=TaskG->V;
  int ncluster;


  Nlist=(int *)s_malloc(sizeof(int)*(V+1));
  Cval=(int *)s_malloc(sizeof(int)*(V+1));
  memset(Cval,0,sizeof(int)*(V+1));
  
  i=u;
  while (ClusterTree[i]!=0)
    i=ClusterTree[i];
  ClusterTree[i]=v;
  i=v;
  while (i!=0){
    Cluster[i]=u;
	i=ClusterTree[i];
  }

  for (i=1;i<=nproc;++i){
    ExecT[(i-1)*V+u]+=ExecT[(i-1)*V+v];
	if ((ExecT[(i-1)*V+u]<BestE[u])||(i==1))
	  BestE[u]=ExecT[(i-1)*V+u];
  }

  Cval[u]=1;
  nsize=0;
  i=u;
  while (i!=0){
    for (m=vlist[i].start;m<vlist[i].end;++m){
	  ncluster=Cluster[elist[m].adj];
	  if (Cval[ncluster]==0)
	    Nlist[nsize++]=ncluster;
	  Cval[ncluster]+=elist[m].wgt;
	}
	i=ClusterTree[i];
  }	 

  max=0;
  for (i=0;i<nsize;++i){
    ncluster=Nlist[i];
	Cval[ncluster]+=BestE[ncluster]+BestE[u];
  	m=TogetherBestProc(ExecT,u,ncluster,nproc,V);
    Cval[ncluster]-=(ExecT[(m-1)*V+ncluster]+ExecT[(m-1)*V+u]);    
	if ((max==0)||(Cval[max]<Cval[ncluster]))
	  max=ncluster;						  
  }

  BestN[u]=max;
  h->vals[u]=Cval[max];
  MaxHeapInsert(h,u);

  for (i=0;i<nsize;++i){
    ncluster=Nlist[i];
    if (h->vals[ncluster]<Cval[ncluster]){
	  BestN[ncluster]=u;
	  h->vals[ncluster]=Cval[u];
	  MaxHeapIncreaseKey(h,ncluster);
	}
	else if ((BestN[ncluster]==u)||(BestN[ncluster]==v)){
	  BestN[ncluster]=TwinFindBestNeigh(ExecT,TaskG,Cluster,ClusterTree,BestE,nproc,ncluster,&max);
	  MaxHeapUpdateKey(h,ncluster,max);
	}
  }

  free(Cval);
  free(Nlist);
}

void TwinAssign(int *ExecT1,graph_type *TaskG1,int nproc,int *Assign){

  int *Cluster,*ClusterTree,*BestN,*BestE,*ExecT;
  graph_type TaskG;
  int i;
  int V;
  vertex_type *vlist;
  edge_type *elist;
  heap h;

  V=TaskG.V=TaskG1->V;
  TaskG.E=TaskG1->E;
  AllocateGraph(&TaskG);
  vlist=TaskG.vlist;
  elist=TaskG.elist;

  memcpy(vlist,TaskG1->vlist,sizeof(vertex_type)*(V+1));
  memcpy(elist,TaskG1->elist,sizeof(edge_type)*(TaskG.E));

  ExecT=(int*)s_malloc(sizeof(int)*(V*nproc+1));
  memcpy(ExecT,ExecT1,sizeof(int)*(V*nproc+1));
  Cluster=(int*)s_malloc(sizeof(int)*(V+1));
  ClusterTree=(int*)s_malloc(sizeof(int)*(V+1));
  BestN=(int*)s_malloc(sizeof(int)*(V+1));
  BestE=(int*)s_malloc(sizeof(int)*(V+1));
  HeapAlloc(&h,V);

  for (i=1;i<=V;++i){
    Cluster[i]=i;
	ClusterTree[i]=0;
    BestE[i]=BestExecT(ExecT,i,nproc,V);
  }

  for (i=1;i<=V;++i){
	BestN[i]=TwinFindBestNeigh(ExecT,&TaskG,Cluster,ClusterTree,BestE,nproc,i,&(h.vals[i]));
    HeapAdd(&h,i);
  }
  
  MaxBuildHeap(&h);
  while (h.size>0){
  
    i=MaxHeapExtractFirst(&h);
    while ((h.vals[i]>0)&&(h.size>0)){
      MaxHeapDelete(&h,BestN[i]);
	  TwinMakeCluster(ExecT,&TaskG,&h,Cluster,ClusterTree,BestN,BestE,nproc,i,BestN[i]);
	  i=MaxHeapExtractFirst(&h);
    }
    MaxHeapInsert(&h,i);
    i=FindHeapMin(&h);
	MaxHeapDelete(&h,i);
	TwinAssignCluster(ExecT,&TaskG,&h,Cluster,ClusterTree,BestN,BestE,nproc,i,Assign);
  }
  
  HeapDealloc(&h);
  FreeGraph(&TaskG);
  free(ExecT);
  free(BestN);
  free(BestE);
  free(Cluster);
  free(ClusterTree);
}
