#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

typedef int *pint;
typedef double ik_timer;

extern long _u_seed;

#define usRandom(s)     _u_seed = s
#define usRandomize     usRandom(time(NULL))

static long uRandom(long l)
{
long   a = 16807;
long   m = 2147483647;
long   q = 127773;
long   r = 2836;
long   lo, hi, test;
double d;
 
lo = _u_seed % q;
hi = _u_seed / q;
test = (a*lo)-(r*hi);
if (test>0)
    _u_seed = test;
else
    _u_seed = test + m;
d = (double) ((double) _u_seed / (double) m);
return (long) (d*(double)l);
}

#define SWAP(a,b,tmp) tmp=a;a=b;b=tmp;

FILE *s_fopen(char *filename,char *mode);
void *s_malloc(int size);
void *s_calloc(int num,int size);
void Error_Exit(char *s);
int s_random(int limit);
void rand_per_int(int *list,int size);
void swap(int *i,int *j);
double GetSeconds(void);
void RandomPermute(int *a,int n);

#define ClearTimer(tmr) (tmr=0)
#define StartTimer(tmr) (tmr-=GetSeconds())
#define StopTimer(tmr)  (tmr+=GetSeconds())
#define GetTimer(tmr)   (tmr)


