#include "graph.h"
#include "util.h"
 

int FindEdge(graph_type *G,int source,int dest){
  
  int i;								     

  for (i=G->vlist[source].start;i<G->vlist[source].end;++i)
    if (G->elist[i].adj==dest)
	  break;
  if (i<G->vlist[source].end)
    return i;
  else
    return -1;
}


void Read_Data(graph_type *TaskG,char *filename){
  
  FILE *ifp;
  int i,m,k,eptr,*index;
  int *Adv,*Next;

  ifp = s_fopen(filename, "r");
  fscanf(ifp,"%d",&(TaskG->V));
  index=(int *)s_malloc(sizeof(int)*(TaskG->V+2));
  Adv=(int *)s_malloc(sizeof(int)*(TaskG->V+1));
  Next=(int *)s_malloc(sizeof(int)*(TaskG->V+1));
  memset(Adv,0,sizeof(int)*(TaskG->V+1));
  TaskG->vlist=(vertex_type *)s_malloc((TaskG->V+1)*sizeof(vertex_type));
  for (i=1;i<=(TaskG->V+1);++i)
    fscanf(ifp,"%d",&(index[i]));
  TaskG->elist=(edge_type *)s_malloc((2*index[TaskG->V+1])*sizeof(edge_type));
  eptr=0;
  for (i=1;i<=TaskG->V;++i){
   	TaskG->vlist[i].start=eptr;
	Next[i]=eptr;
	eptr+=Adv[i];
   	for (m=index[i];m<index[i+1];++m){ 
	  fscanf(ifp,"%d",&k);
	  if (k!=i){
	    TaskG->elist[eptr++].adj=k;
	    ++Adv[k];
	  }
	}
	TaskG->vlist[i].end=eptr;
  }
  
  TaskG->E=eptr;
  for (i=1;i<=TaskG->V;++i)
    for (m=TaskG->vlist[i].start+Adv[i];m<TaskG->vlist[i].end;++m){ 
      k=TaskG->elist[m].adj;
      TaskG->elist[Next[k]].adj=i;
      ++Next[k];
    }

  fclose(ifp);
  free(index);
  free(Adv);
  free(Next);
}

void Write_Data(int *ExecT,graph_type *TaskG,int nproc,char *filename){
  
  FILE *ofp;
  int i,m;

  ofp = s_fopen(filename, "w");
  fprintf(ofp," %d",nproc);
  fprintf(ofp," %d",TaskG->V);
  fprintf(ofp," %d\n",TaskG->E);
  for (i=1;i<=nproc;++i){
    for (m=1;m<=TaskG->V;++m)
	  fprintf(ofp," %d",ExecT[(i-1)*TaskG->V+m]);
	fprintf(ofp,"\n");
  }
  for (i=1;i<=TaskG->V;++i){
   	for (m=TaskG->vlist[i].start;m<TaskG->vlist[i].end;++m)
      fprintf(ofp," %d %d",TaskG->elist[m].adj,TaskG->elist[m].wgt);
    fprintf(ofp,"\n");
  }
  fclose(ofp);
}
